package cn.itcast;
/*
 * 
 * 游戏过程工具类,实现产生庄/洗牌发牌/打印目前牌友状态/结算/牌友 与牌相关的状态重置功能
 * 
 * */
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;
import java.util.Scanner;

public class GameProcess {

	public static GambleFriend[] player = OxGame.player;
	public static ArrayList<Pai> pai = OxGame.pai;
	public static int banker;

	// 随机产生庄/随机注的方法
	public static int getRandom(int r) {
		// TODO Auto-generated method stub
		Random random = new Random();
		return random.nextInt(r);
	}

	// 产生庄
	public static void getBanker(GambleFriend[] player, int ai) {
		banker = getRandom(ai + 1);
		player[banker].setStatus("庄");
		System.out.println("此轮的庄是: " + player[banker].getName());
	}

	// 闲家下注功能
	public static void setPlayerCount() {
		if (banker != player.length - 1) {
			// 说明你不是庄 ,你自己下注
			System.out.println("此轮你不是庄,请下注 (10,20,30,40,输0结束游戏):");
			Scanner scanner = new Scanner(System.in);
			while (true) {
				int count = scanner.nextInt();

				if (count == 0) {
					System.exit(0);
				} else if (count != 10 && count != 20 && count != 30
						&& count != 40) {
					System.out.println("输入非法");
					continue;
				} else {
					player[player.length - 1].setCounter(count);
					break;
				}
			}
		} else {
			System.out.println("此轮你是庄,不用下注,下注额显示0");
		}

		// 闲家AI 随机下注
		for (int i = 0; i < player.length - 1; i++) {
			if (i == banker)
				continue;// 庄家不用下注
			player[i].setCounter((getRandom(4) + 1) * 10);
		}
	}

	// 庄洗牌及发牌
	public static void shuffleCards() {
		System.out.println("庄家:" + player[banker].getName() + "洗牌...");
		for (int i = 0; i < 3; i++) {
			Collections.shuffle(pai);
		}
		// 发牌
		System.out.println("庄家:" + player[banker].getName() + "发牌...");
		for (int i = 0; i < (player.length + 1) * 5; i++) {
			for (int j = 0; j < player.length; j++) {
				if (i % (player.length + 1) == j) {
					player[j].setPai(pai.get(i));
				}
			}
		}
	}

	// 显示每个牌友的得到牌组后目前的状态
	public static void show() {
		for (int i = 0; i < player.length; i++) {
			System.out.println(player[i].getPai());
			Collections.sort(player[i].getPai(), new MyComparator());
			Common.countNiu(player[i]);
		}
		System.out.println("庄家的状态:");
		player[banker].show();

		System.out.println("闲家的状态:");
		for (int i = 0; i < player.length; i++) {
			if (i == banker)
				continue;//
			player[i].show();
		}
	}

	// 结算
	public static void countMoney() {
		System.out.println("结算:");
		for (int i = 0; i < player.length; i++) {
			if (i == banker)
				continue;
			Common.money(player[banker], player[i]);
		}
	}

	// 打印此轮过后各位牌友口袋里的钱
	public static void resultNow() {
		System.out.println("此轮过后,赌友钱数: ");
		for (int i = 0; i < player.length; i++) {
			System.out.print("[" + player[i].getName() + " :"
					+ player[i].getMoney() + "] ");
		}
		System.out.println();
	}

	// 重置每个玩家的牌组 牌值 倍数
	public static void resetStatus() {
		for (int i = 0; i < player.length; i++) {
			player[i].getPai().clear();
			player[i].getPai().clear();
			player[i].setStatus("闲");
			player[i].setCounter(0);
			player[i].setBeishu(1);
		}
	}
}
