/** 
 * 牌面比较器,没有直接比较牌值和花色,
 * 而是通过牌值和花色对应索引来比较(方便花牌和王牌的大小排序) 
 */
package cn.itcast;

import java.util.Comparator;

public class MyComparator implements Comparator<Pai> {

	// 定义索引数组 通过获取对应索引方便比较大小
	// 牌值索引数组
	// String[] arrnum = { "3", "4", "5", "6", "7", "8", "9", "10", "J", "Q",
	// "K",
	// "A", "2", "王" };
	// 花色索引数组
	// String[] arrcolor = { "♠", "♡", "♣", "♢", "小", "大" };

	String[] arrnum = { "A", "2", "3", "4", "5", "6", "7", "8", "9", "10", "J",
			"Q", "K", "牛" };
	String[] arrcolor = { "♠", "♡", "♣", "♢", "牛" };

	// 初始牌组排序:先比牌值,再比花色-->通过牌值和花色获取索引,先比较牌值索引,再比较花色索引
	@Override
	public int compare(Pai o1, Pai o2) {
		// TODO Auto-generated method stub
		int result = getIndex(arrnum, o1.getNum())
				- getIndex(arrnum, o2.getNum());
		result = (result == 0) ? (getIndex(arrcolor, o1.getColor()) - getIndex(
				arrcolor, o2.getColor())) : result;
		return result;
	}

	// "结果牌"比较器 :先比花色,再比牌值
	public int compare2(Pai banker, Pai other) {
		// TODO Auto-generated method stub
		int result = 0;
		if (banker.getColor().equals("牛") && !(other.getColor().equals("牛"))) {
			return 1;
		} else if (!(banker.getColor().equals("牛"))
				&& other.getColor().equals("牛")) {
			return -1;
		} else {
			result = getIndex(arrnum, banker.getNum())
					- getIndex(arrnum, other.getNum());
			result = (result == 0) ? (getIndex(arrcolor, other.getColor()) - getIndex(
					arrcolor, banker.getColor())) : result;
		}
		return result;
	}

	// 索引获取方法
	public int getIndex(String[] arr, String key) {
		for (int i = 0; i < arr.length; i++) {
			if (arrnum[i].equals(key)) {
				return i;
			}
		}
		return -1;
	}

}
